]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blame - scripts/link-vmlinux.sh
net: nfc: nci: fix the wrong NCI_CORE_INIT parameters
[mirror_ubuntu-jammy-kernel.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
3ec8a5b3
MY
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
1f2bfbd0
SR
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41 if [ "${quiet}" != "silent_" ]; then
e83b9f55 42 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
43 fi
44}
45
46# Link of vmlinux.o used for section mismatch analysis
47# ${1} output file
48modpost_link()
49{
a5967db9
SR
50 local objects
51
6358d6e8 52 objects="--whole-archive \
d151e971 53 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
54 --no-whole-archive \
55 --start-group \
56 ${KBUILD_VMLINUX_LIBS} \
57 --end-group"
58
d503ac53 59 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
1f2bfbd0
SR
60}
61
6804c1af
PZ
62objtool_link()
63{
64 local objtoolopt;
65
66 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
67 objtoolopt="check"
68 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
69 objtoolopt="${objtoolopt} --no-fp"
70 fi
71 if [ -n "${CONFIG_GCOV_KERNEL}" ]; then
72 objtoolopt="${objtoolopt} --no-unreachable"
73 fi
74 if [ -n "${CONFIG_RETPOLINE}" ]; then
75 objtoolopt="${objtoolopt} --retpoline"
76 fi
77 if [ -n "${CONFIG_X86_SMAP}" ]; then
78 objtoolopt="${objtoolopt} --uaccess"
79 fi
80 info OBJTOOL ${1}
81 tools/objtool/objtool ${objtoolopt} ${1}
82 fi
83}
84
1f2bfbd0 85# Link of vmlinux
341dfcf8 86# ${1} - output file
618916a4 87# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
88vmlinux_link()
89{
90 local lds="${objtree}/${KBUILD_LDS}"
618916a4 91 local output=${1}
a5967db9 92 local objects
af73d78b 93 local strip_debug
1f2bfbd0 94
d7b0827f
LT
95 info LD ${output}
96
618916a4
AN
97 # skip output file argument
98 shift
99
af73d78b
KC
100 # The kallsyms linking does not need debug symbols included.
101 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
102 strip_debug=-Wl,--strip-debug
103 fi
104
1f2bfbd0 105 if [ "${SRCARCH}" != "um" ]; then
6358d6e8 106 objects="--whole-archive \
d151e971 107 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
108 --no-whole-archive \
109 --start-group \
110 ${KBUILD_VMLINUX_LIBS} \
111 --end-group \
618916a4 112 ${@}"
a5967db9 113
618916a4 114 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
af73d78b 115 ${strip_debug#-Wl,} \
618916a4 116 -o ${output} \
a5967db9 117 -T ${lds} ${objects}
1f2bfbd0 118 else
6358d6e8 119 objects="-Wl,--whole-archive \
d151e971 120 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
121 -Wl,--no-whole-archive \
122 -Wl,--start-group \
123 ${KBUILD_VMLINUX_LIBS} \
124 -Wl,--end-group \
618916a4 125 ${@}"
a5967db9 126
618916a4 127 ${CC} ${CFLAGS_vmlinux} \
af73d78b 128 ${strip_debug} \
618916a4 129 -o ${output} \
6358d6e8
NP
130 -Wl,-T,${lds} \
131 ${objects} \
a5967db9 132 -lutil -lrt -lpthread
1f2bfbd0
SR
133 rm -f linux
134 fi
135}
136
e83b9f55 137# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
138# ${1} - vmlinux image
139# ${2} - file to dump raw BTF data into
e83b9f55
AN
140gen_btf()
141{
341dfcf8 142 local pahole_ver
e83b9f55 143
581b31c3 144 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 145 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 146 return 1
581b31c3
AN
147 fi
148
e83b9f55 149 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
150 if [ "${pahole_ver}" -lt "116" ]; then
151 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 152 return 1
e83b9f55
AN
153 fi
154
341dfcf8 155 vmlinux_link ${1}
af73d78b
KC
156
157 info "BTF" ${2}
e83b9f55 158 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
341dfcf8 159
90ceddcb
FS
160 # Create ${2} which contains just .BTF section but no symbols. Add
161 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
162 # deletes all symbols including __start_BTF and __stop_BTF, which will
163 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
164 # objcopy warnings: "empty loadable segment detected at ..."
165 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
166 --strip-all ${1} ${2} 2>/dev/null
167 # Change e_type to ET_REL so that it can be used to link final vmlinux.
168 # Unlike GNU ld, lld does not allow an ET_EXEC input.
169 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 170}
1f2bfbd0 171
08beb669 172# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
173kallsyms()
174{
1f2bfbd0
SR
175 local kallsymopt;
176
177 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 178 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
179 fi
180
4d5d5664 181 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
182 kallsymopt="${kallsymopt} --absolute-percpu"
183 fi
184
2213e9a6
AB
185 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
186 kallsymopt="${kallsymopt} --base-relative"
187 fi
188
08beb669
MY
189 info KSYMS ${2}
190 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
1f2bfbd0
SR
191}
192
8959e392
KC
193# Perform one step in kallsyms generation, including temporary linking of
194# vmlinux.
195kallsyms_step()
196{
197 kallsymso_prev=${kallsymso}
af73d78b
KC
198 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
199 kallsymso=${kallsyms_vmlinux}.o
08beb669 200 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 201
d7b0827f 202 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
08beb669
MY
203 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
204
205 info AS ${kallsyms_S}
206 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
207 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
208 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
209}
210
1f2bfbd0
SR
211# Create map file with all symbols from ${1}
212# See mksymap for additional details
213mksysmap()
214{
215 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
216}
217
10916706 218sorttable()
1347a2ce 219{
10916706 220 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
221}
222
1f2bfbd0 223# Delete output files in case of error
1f2bfbd0
SR
224cleanup()
225{
341dfcf8 226 rm -f .btf.*
1f2bfbd0 227 rm -f .tmp_System.map
1f2bfbd0
SR
228 rm -f .tmp_vmlinux*
229 rm -f System.map
230 rm -f vmlinux
231 rm -f vmlinux.o
232}
233
ab160dbb
SB
234on_exit()
235{
236 if [ $? -ne 0 ]; then
237 cleanup
238 fi
239}
240trap on_exit EXIT
241
242on_signals()
243{
244 exit 1
245}
246trap on_signals HUP INT QUIT TERM
247
1f2bfbd0
SR
248# Use "make V=1" to debug this script
249case "${KBUILD_VERBOSE}" in
250*1*)
251 set -x
252 ;;
253esac
254
255if [ "$1" = "clean" ]; then
256 cleanup
257 exit 0
258fi
259
260# We need access to CONFIG_ symbols
94cf8acc 261. include/config/auto.conf
1f2bfbd0 262
1f2bfbd0
SR
263# Update version
264info GEN .version
278ae604
MY
265if [ -r .version ]; then
266 VERSION=$(expr 0$(cat .version) + 1)
267 echo $VERSION > .version
1f2bfbd0 268else
278ae604
MY
269 rm -f .version
270 echo 1 > .version
1f2bfbd0
SR
271fi;
272
273# final build of init/
083bc0e1 274${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
1f2bfbd0 275
abac4c89
NP
276#link vmlinux.o
277info LD vmlinux.o
278modpost_link vmlinux.o
6804c1af 279objtool_link vmlinux.o
abac4c89
NP
280
281# modpost vmlinux.o to check for section mismatches
a721588d 282${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 283
898490c0
AG
284info MODINFO modules.builtin.modinfo
285${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
8b41fc44
MY
286info GEN modules.builtin
287# The second line aids cases where multiple modules share the same object.
288tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
289 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
898490c0 290
7fd78568 291btf_vmlinux_bin_o=""
341dfcf8 292if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
af73d78b
KC
293 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
294 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
295 echo >&2 "Failed to generate BTF for vmlinux"
296 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
297 exit 1
341dfcf8
AN
298 fi
299fi
300
1f2bfbd0 301kallsymso=""
8959e392 302kallsymso_prev=""
1f2bfbd0
SR
303kallsyms_vmlinux=""
304if [ -n "${CONFIG_KALLSYMS}" ]; then
305
306 # kallsyms support
307 # Generate section listing all symbols and add it into vmlinux
308 # It's a three step process:
309 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
310 # but __kallsyms is empty.
311 # Running kallsyms on that gives us .tmp_kallsyms1.o with
312 # the right size
313 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
314 # the right size, but due to the added section, some
315 # addresses have shifted.
316 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
317 # 3) That link may have expanded the kernel image enough that
318 # more linker branch stubs / trampolines had to be added, which
319 # introduces new names, which further expands kallsyms. Do another
320 # pass if that is the case. In theory it's possible this results
321 # in even more stubs, but unlikely.
322 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
323 # other bugs.
324 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
325 #
326 # a) Verify that the System.map from vmlinux matches the map from
327 # ${kallsymso}.
328
8959e392
KC
329 kallsyms_step 1
330 kallsyms_step 2
1f2bfbd0 331
7e2b37c9 332 # step 3
8959e392
KC
333 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
334 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
335
336 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 337 kallsyms_step 3
1f2bfbd0
SR
338 fi
339fi
340
d7b0827f 341vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 342
c9a0f3b8 343# fill in BTF IDs
017dab34
JO
344if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
345 info BTFIDS vmlinux
346 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
347fi
348
10916706
SZ
349if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
350 info SORTTAB vmlinux
f14bf6a3
SZ
351 if ! sorttable vmlinux; then
352 echo >&2 Failed to sort kernel tables
353 exit 1
354 fi
1347a2ce
LT
355fi
356
1f2bfbd0
SR
357info SYSMAP System.map
358mksysmap vmlinux System.map
359
360# step a (see comment above)
361if [ -n "${CONFIG_KALLSYMS}" ]; then
362 mksysmap ${kallsyms_vmlinux} .tmp_System.map
363
364 if ! cmp -s System.map .tmp_System.map; then
5369f550 365 echo >&2 Inconsistent kallsyms data
367e43c5 366 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
367 exit 1
368 fi
369fi